#import "WeChatVideoDownloader.h"

static MMTableViewCell *iOSRECell;
static MMTableView *iOSREView;
static WCTimeLineViewController *iOSREController;

%hook WCContentItemViewTemplateNewSight
%new
- (WCMediaItem *)iOSREMediaItemFromSight
{
	id responder = self;
	while (![responder isKindOfClass:NSClassFromString(@"WCTimeLineViewController")])
	{
		if ([responder isKindOfClass:NSClassFromString(@"MMTableViewCell")]) iOSRECell = responder;
		else if ([responder isKindOfClass:NSClassFromString(@"MMTableView")]) iOSREView = responder;
		responder = [responder nextResponder];
	}
	iOSREController = responder;
	if (!iOSRECell || !iOSREView || !iOSREController)
	{
		NSLog(@"iOSRE: Failed to get video object.");
		return nil;
	}
	NSIndexPath *indexPath = [iOSREView indexPathForCell:iOSRECell];
	int itemIndex = [iOSREController calcDataItemIndex:[indexPath section]];
	WCFacade *facade = [(MMServiceCenter *)[%c(MMServiceCenter) defaultCenter] getService:[%c(WCFacade) class]];
	WCDataItem *dataItem = [facade getTimelineDataItemOfIndex:itemIndex];
	WCContentItem *contentItem = dataItem.contentObj;
	WCMediaItem *mediaItem = [contentItem.mediaList count] != 0 ? (contentItem.mediaList)[0] : nil;
	return mediaItem;
}

%new
- (void)iOSREOnSaveToDisk
{
	NSString *localPath = [[self iOSREMediaItemFromSight] pathForSightData];
	UISaveVideoAtPathToSavedPhotosAlbum(localPath, nil, nil, nil);
}

%new
- (void)iOSREOnCopyURL
{
	UIPasteboard *pasteboard = [UIPasteboard generalPasteboard];
	pasteboard.string = [self iOSREMediaItemFromSight].dataUrl.url;
}

static int iOSRECounter;

- (void)onLongTouch
{
	iOSRECounter++;
	if (iOSRECounter % 2 == 0) return;
	
	[self becomeFirstResponder];
	
	UIMenuItem *saveToDiskMenuItem = [[UIMenuItem alloc] initWithTitle:@"Save to Disk" action:@selector(iOSREOnSaveToDisk)];
	UIMenuItem *copyURLMenuItem = [[UIMenuItem alloc] initWithTitle:@"Copy URL" action:@selector(iOSREOnCopyURL)];
	
	UIMenuController *menuController = [UIMenuController sharedMenuController];
	[menuController setMenuItems:@[saveToDiskMenuItem, copyURLMenuItem]];
	[menuController setTargetRect:CGRectZero inView:self];
	[menuController setMenuVisible:YES animated:YES];
	
	[saveToDiskMenuItem release];
	[copyURLMenuItem release];
}
%end
